require 'api_consumer'

class EME::Auth < APIConsumer
  
  def self.make_ticket(game_account_id, conn = connection)
    do_request("/ticket/#{game_account_id}", conn)
  end
  
  #http://auth.service.edge.enmasse.com:4567/ticket/TGmMuniGyatDoTnythxyoT-pvad3gTRmRmmiwxv4ozsHK-tgd-/verify_simple
  def self.verify_simple_ticket(ticket, conn = connection)
    path = URI.encode("/ticket/#{ticket}/verify_simple")
    do_request(path, conn, {:method => :post, :errors => {'404' => 'Ticket not found or already used.'}})
  end
  
  def self.verify_ticket(ticket, conn = connection)
    path = URI.encode("/ticket/#{ticket}/verify")
    do_request(path, conn, {:method => :post, :errors => {'404' => 'Ticket not found or already used.'}})
  end

  def self.generate_authentication_token(game_account_id, conn = connection)
    do_request("/api/v1/generate_authentication_token?game_account_id=#{game_account_id}", conn)
  end

end
