require 'api_consumer'

module EME
  class Lootbox < APIConsumer
    def self.definitions(game_id = nil, conn = connection, opts = {}, reload = false)
      opts[:reload] ||= reload
      opts[:ttl] ||= 900
      path = "/loot_box_definitions"
      path += "?game_id=#{game_id}" if game_id
      return do_request(path, conn, opts)
    end

    def self.lootboxes(game_account_id, conn = connection, opts = {}, reload = false)
      opts[:reload] ||= reload
      opts[:ttl] ||= 1
      return do_request("/loot_boxes?game_account_id=#{game_account_id}", conn, opts)
    end

    def self.open(loot_box_id, game_account_id, token, conn = connection, opts = {}, reload = false)
      opts[:reload] ||= reload
      opts[:method] = :post
      opts[:ttl] ||= 1
      opts[:body] = {id: loot_box_id, game_account_id: game_account_id, token: token}.to_json
      return do_request("/loot_boxes/open", conn, opts)
    end
  end
end
