class EME::TeraServer::Server
  attr_reader :name, :id, :kind, :message, :crowd, :open
  def initialize(opts)
    @name = opts[:name]
    @id = opts[:id].to_i
    @kind = opts[:kind]
    @status_flag = opts[:status_flag]
    @message = opts[:message]
    @crowd = opts[:crowd]
    @open = opts[:open]
  end

  def abbr
    return EME::TeraServer::Server.abbr(self.name)
  end

  def status
    return "Up" if up?
    return "Down" if down?
    return "Maintenance"
  end

  def maintenance?
    @status_flag.to_i(16) == 0x100
  end

  def up?
    @status_flag.to_i(16) < 0x100
  end

  def down?
    @status_flag.to_i(16) > 0x100
  end

  def self.abbr(server_name)
    return PRESET_ABBR[server_name] if PRESET_ABBR[server_name]
    tmp = server_name.split(' ')
    return(tmp[0][0] + tmp[1][0]).upcase if tmp.length > 1
    (tmp[0][0] + tmp[0][1]).upcase
  end
  PRESET_ABBR = {"Highwatch" => 'HW', "Lake of Tears" => "LT", "Valley of Titans" => "VT", "New Pora" => "PA"}.freeze
  
  def self.server_id(server_name)
    
  end

end
